﻿// <auto-generated />
using System;
using EFDDD.Infrastructure.EFCore;
using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Infrastructure;
using Microsoft.EntityFrameworkCore.Storage.ValueConversion;
using Oracle.EntityFrameworkCore.Metadata;

#nullable disable

namespace EFDDD.Infrastructure.Migrations
{
    [DbContext(typeof(FreeDbContext))]
    partial class FreeDbContextModelSnapshot : ModelSnapshot
    {
        protected override void BuildModel(ModelBuilder modelBuilder)
        {
#pragma warning disable 612, 618
            modelBuilder
                .HasAnnotation("ProductVersion", "8.0.0")
                .HasAnnotation("Relational:MaxIdentifierLength", 128);

            OracleModelBuilderExtensions.UseIdentityColumns(modelBuilder);

            modelBuilder.Entity("EFDDD.Domain.Entities.LogEntity", b =>
                {
                    b.Property<long>("LogId")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("NUMBER(19)")
                        .HasColumnName("LOG_ID");

                    OraclePropertyBuilderExtensions.UseIdentityColumn(b.Property<long>("LogId"));

                    b.Property<DateTime>("LogDate")
                        .HasColumnType("TIMESTAMP(7)")
                        .HasColumnName("LOG_DATE");

                    b.Property<string>("LogText")
                        .IsRequired()
                        .HasColumnType("NVARCHAR2(2000)")
                        .HasColumnName("LOG_TEXT");

                    b.HasKey("LogId");

                    b.ToTable("LOGS");
                });

            modelBuilder.Entity("EFDDD.Domain.Entities.ProductEntity", b =>
                {
                    b.Property<int>("ProductId")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("NUMBER(10)")
                        .HasColumnName("PRODUCT_ID");

                    OraclePropertyBuilderExtensions.UseIdentityColumn(b.Property<int>("ProductId"));

                    b.Property<int>("Price")
                        .HasColumnType("NUMBER(10)")
                        .HasColumnName("PRICE");

                    b.Property<string>("ProductName")
                        .IsRequired()
                        .HasColumnType("NVARCHAR2(2000)")
                        .HasColumnName("PRODUCT_NAME");

                    b.HasKey("ProductId");

                    b.ToTable("PRODUCTS");
                });

            modelBuilder.Entity("EFDDD.Domain.Entities.ProductItemEntity", b =>
                {
                    b.Property<int>("ProductId")
                        .HasColumnType("NUMBER(10)")
                        .HasColumnName("PRODUCT_ID");

                    b.Property<int>("ProductItemNo")
                        .HasColumnType("NUMBER(10)")
                        .HasColumnName("PRODUCT_ITEM_NO");

                    b.Property<string>("ProductItemName")
                        .IsRequired()
                        .HasColumnType("NVARCHAR2(2000)")
                        .HasColumnName("PRODUCT_ITEM_NAME");

                    b.HasKey("ProductId", "ProductItemNo");

                    b.ToTable("PRODUCT_ITEMS");
                });

            modelBuilder.Entity("EFDDD.Domain.Entities.ProductItemEntity", b =>
                {
                    b.HasOne("EFDDD.Domain.Entities.ProductEntity", "Product")
                        .WithMany("ProductItems")
                        .HasForeignKey("ProductId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.OwnsOne("EFDDD.Domain.ValueObjects.GlobalPrice", "GlobalPrice", b1 =>
                        {
                            b1.Property<int>("ProductItemEntityProductId")
                                .HasColumnType("NUMBER(10)");

                            b1.Property<int>("ProductItemEntityProductItemNo")
                                .HasColumnType("NUMBER(10)");

                            b1.Property<decimal>("Amount")
                                .HasColumnType("DECIMAL(19, 2)")
                                .HasColumnName("AMOUNT");

                            b1.Property<string>("Currency")
                                .IsRequired()
                                .HasColumnType("NVARCHAR2(2000)")
                                .HasColumnName("CURRENCY");

                            b1.HasKey("ProductItemEntityProductId", "ProductItemEntityProductItemNo");

                            b1.ToTable("PRODUCT_ITEMS");

                            b1.WithOwner()
                                .HasForeignKey("ProductItemEntityProductId", "ProductItemEntityProductItemNo");
                        });

                    b.Navigation("GlobalPrice")
                        .IsRequired();

                    b.Navigation("Product");
                });

            modelBuilder.Entity("EFDDD.Domain.Entities.ProductEntity", b =>
                {
                    b.Navigation("ProductItems");
                });
#pragma warning restore 612, 618
        }
    }
}
